#ifndef _MilleTool_H
#define _MilleTool_H 1

#include "Plane.h"

#include "Millepede.h"
#include "IMilleTool.h"
#include "Track.h"
#include "TRandom.h" 

#include <vector>

/** interface to MilleTool tool */

class MilleTool: public IMilleTool {

 public:

  MilleTool():m_nTrack(0){}  

  virtual ~MilleTool(){}

  virtual bool initialize(const Planes& geom) ;

  virtual bool addTrack(Track trueTrack, 
			const std::vector<double>& m_offsetX, 
			const std::vector<double>& m_offsetY, 
			const std::vector<double>& m_offsetZ, 
			const std::vector<double>& m_offsetA, 
			const std::vector<double>& m_offsetB, 
			const std::vector<double>& m_offsetC, 
			const std::vector<double>& smearX,
			const std::vector<double>& smearY);

  virtual bool globalFit() ;

  virtual const std::vector<double>& parameters() const;

  virtual const std::vector<double>& errors() const;

  virtual const std::vector<double>& pulls() const;

  void reset();

 private:

 Planes m_geometry;
 Millepede  m_alignTool;
 unsigned int m_nTrack;

 TRandom* m_generator;

  // vectors
  std::vector<double> m_par;
  std::vector<double> m_error;
  std::vector<double> m_pull;
  std::vector<double> xTrue;
  std::vector<double> Xmeas;
  std::vector<double> yTrue;
  std::vector<double> Ymeas;

};

#endif
